-- B43001M.ADA

--                             Grant of Unlimited Rights
--
--     Under contracts F33600-87-D-0337, F33600-84-D-0280, MDA903-79-C-0687,
--     F08630-91-C-0015, and DCA100-97-D-0025, the U.S. Government obtained 
--     unlimited rights in the software and documentation contained herein.
--     Unlimited rights are defined in DFAR 252.227-7013(a)(19).  By making 
--     this public release, the Government intends to confer upon all 
--     recipients unlimited rights  equal to those held by the Government.  
--     These rights include rights to use, duplicate, release or disclose the 
--     released technical data and computer software in whole or in part, in 
--     any manner and for any purpose whatsoever, and to have or permit others 
--     to do so.
--
--                                    DISCLAIMER
--
--     ALL MATERIALS OR INFORMATION HEREIN RELEASED, MADE AVAILABLE OR
--     DISCLOSED ARE AS IS.  THE GOVERNMENT MAKES NO EXPRESS OR IMPLIED 
--     WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING THE CONDITIONS OF THE
--     SOFTWARE, DOCUMENTATION OR OTHER INFORMATION RELEASED, MADE AVAILABLE 
--     OR DISCLOSED, OR THE OWNERSHIP, MERCHANTABILITY, OR FITNESS FOR A
--     PARTICULAR PURPOSE OF SAID MATERIAL.
--*
-- OBJECTIVE:
--     CHECK THAT AGGREGATES CANNOT BE WRITTEN FOR LIMITED ARRAY OR
--     RECORD TYPES.

-- HISTORY:
--     BCB 07/07/88  CREATED ORIGINAL TEST.
--     THS 03/28/90  MOVED "-- ERROR:" TO THE RIGHT OF THE CONSTRUCT
--                   IN ERROR.

PROCEDURE B43001M IS

     TASK TYPE T IS
          ENTRY ONE(VAL1 : IN OUT INTEGER);
     END T;

     PACKAGE LP IS
          TYPE LIM IS LIMITED PRIVATE;
          L : CONSTANT LIM;
          FUNCTION INIT RETURN LIM;
     PRIVATE
          TYPE LIM IS RANGE 1 .. 100;
          L : CONSTANT LIM := 5;
     END LP;

     USE LP;

     TYPE LIM_ARR1 IS ARRAY(1..5) OF LIM;

     TYPE LIM_ARR2 IS ARRAY(1..5) OF T;

     TYPE LIM_REC1 (D : INTEGER) IS RECORD
          COMP : LIM;
     END RECORD;

     TYPE LIM_REC2 (D : INTEGER) IS RECORD
          COMP : T;
     END RECORD;

     TOBJ : T;

     PACKAGE BODY LP IS
          FUNCTION INIT RETURN LIM IS
          BEGIN
               RETURN 10;
          END INIT;
     END LP;

     PROCEDURE PLIM_ARR1 (W : LIM_ARR1) IS
     BEGIN
          NULL;
     END PLIM_ARR1;

     PROCEDURE PLIM_ARR2 (X : LIM_ARR2) IS
     BEGIN
          NULL;
     END PLIM_ARR2;

     PROCEDURE PLIM_REC1 (Y : LIM_REC1) IS
     BEGIN
          NULL;
     END PLIM_REC1;

     PROCEDURE PLIM_REC2 (Z : LIM_REC2) IS
     BEGIN
          NULL;
     END PLIM_REC2;

     TASK BODY T IS
     BEGIN
          ACCEPT ONE(VAL1 : IN OUT INTEGER);
     END T;

BEGIN
     PLIM_ARR1 ((1 => 1, 2 => 2, 3 => 3, 4 => 4, 5 => 5)); -- ERROR:
                               -- LIMITED ARRAY, LIMITED COMPONENTS.

     PLIM_REC1 ((D => 3, COMP => 5));                      -- ERROR:
                              -- LIMITED RECORD, LIMITED COMPONENTS.

     PLIM_ARR2 ((1..5 => TOBJ));                           -- ERROR:
                                  -- LIMITED ARRAY, TASK COMPONENTS.

     PLIM_REC2 ((D => 3, COMP => TOBJ));                   -- ERROR:
                                 -- LIMITED RECORD, TASK COMPONENTS.

     PLIM_ARR1 ((1..5 => INIT));                           -- ERROR:
                               -- LIMITED ARRAY, LIMITED COMPONENTS.

     PLIM_ARR2 ((TOBJ,TOBJ,TOBJ,TOBJ,TOBJ));               -- ERROR:
                                  -- LIMITED ARRAY, TASK COMPONENTS.

     PLIM_REC1 ((D => 3, COMP => INIT));                   -- ERROR:
                              -- LIMITED RECORD, LIMITED COMPONENTS.

     PLIM_REC2 ((3,TOBJ));                                 -- ERROR:
                                --  LIMITED RECORD, TASK COMPONENTS.

END B43001M;
