-- B58001A.ADA

--                             Grant of Unlimited Rights
--
--     Under contracts F33600-87-D-0337, F33600-84-D-0280, MDA903-79-C-0687,
--     F08630-91-C-0015, and DCA100-97-D-0025, the U.S. Government obtained 
--     unlimited rights in the software and documentation contained herein.
--     Unlimited rights are defined in DFAR 252.227-7013(a)(19).  By making 
--     this public release, the Government intends to confer upon all 
--     recipients unlimited rights  equal to those held by the Government.  
--     These rights include rights to use, duplicate, release or disclose the 
--     released technical data and computer software in whole or in part, in 
--     any manner and for any purpose whatsoever, and to have or permit others 
--     to do so.
--
--                                    DISCLAIMER
--
--     ALL MATERIALS OR INFORMATION HEREIN RELEASED, MADE AVAILABLE OR
--     DISCLOSED ARE AS IS.  THE GOVERNMENT MAKES NO EXPRESS OR IMPLIED 
--     WARRANTY AS TO ANY MATTER WHATSOEVER, INCLUDING THE CONDITIONS OF THE
--     SOFTWARE, DOCUMENTATION OR OTHER INFORMATION RELEASED, MADE AVAILABLE 
--     OR DISCLOSED, OR THE OWNERSHIP, MERCHANTABILITY, OR FITNESS FOR A
--     PARTICULAR PURPOSE OF SAID MATERIAL.
--*
-- CHECK THAT A RETURN STATEMENT CANNOT APPEAR OUTSIDE
--    THE BODY OF A SUBPROGRAM.

-- DCB 2/1/80
-- JRK 11/3/80
-- SPS 3/7/83

PROCEDURE B58001A IS

     PACKAGE P IS
          I : INTEGER;
     END P;

     PACKAGE BODY P IS
     BEGIN
          RETURN;   -- ERROR: RETURN STATEMENT USED OUTSIDE SUBPROGRAM
                    --        TO LEAVE A PACKAGE BODY.
     END P;

BEGIN

     DECLARE

          PACKAGE P IS
               I : INTEGER;
          END P;

          PACKAGE BODY P IS
          BEGIN
               RETURN;   -- ERROR: RETURN STATEMENT USED OUTSIDE 
                         --        SUBPROGRAM TO LEAVE A PACKAGE BODY.
          END P;

     BEGIN
          NULL;
     END;

END B58001A;
